import 'package:string_converter/src/helper.dart';

String utf16(String text, bool remove) {
  try {
    /// get code points
    var codePoints = getCodePoints(text);

    var gucciUtf16 = [];

    /// for loop
    for (var i = 0; i < codePoints.length; i++) {
      var codePoint = codePoints[i];
      var utf16 = codePointToUtf16(codePoint);
      gucciUtf16.add(utf16);
    }

    var ret = "";
    for (var i = 0; i < gucciUtf16.length; i++) {
      var utf16 = gucciUtf16[i];
      if (utf16.length == 1) {
        var val = utf16[0];
        var hexVal = int.parse(val.toString()).toRadixString(16);
        while (hexVal.length < 4) {
          hexVal = "0" + hexVal;
        }
        hexVal = remove ? hexVal : "\\u$hexVal";
        ret += hexVal;
      } else {
        var val2 = utf16[0];
        var val1 = utf16[1];
        var hexVal2 = int.parse(val2.toString()).toRadixString(16);
        while (hexVal2.length < 4) {
          hexVal2 = "0" + hexVal2;
        }
        hexVal2 = remove ? hexVal2 : "\\u$hexVal2";
        ret += hexVal2;
        var hexVal1 = int.parse(val1.toString()).toRadixString(16);
        while (hexVal1.length < 4) {
          hexVal1 = "0" + hexVal1;
        }
        hexVal1 = remove ? hexVal1 : "\\u$hexVal1";
        ret += hexVal1;
      }

      if ((i != gucciUtf16.length - 1) && remove) {
        ret += " ";
      }
    }

    /// return text
    return ret;
  } catch (_) {
    return null;
  }
}

/// code point to utf16
List codePointToUtf16(codePoint) {
  var utf16;
  if (codePoint <= 0xffff) {
    utf16 = [codePoint];
  } else {
    var minus10000 = codePoint - 0x10000;
    var byte2 = (minus10000 >> 10) + 0xD800;
    var byte1 = (minus10000 & bin("1111111111")) + 0xDC00;
    utf16 = [byte2, byte1];
  }

  /// return list
  return utf16;
}
