import 'package:string_converter/src/helper.dart';

String utf32(String text, bool remove) {
  try {
    /// get code points
    var codePoints = getCodePoints(text);

    var gucciUtf32 = [];

    /// for loop
    for (var i = 0; i < codePoints.length; i++) {
      var codePoint = codePoints[i];
      var utf32 = codePointToUtf32(codePoint);
      gucciUtf32.add(utf32);
    }

    var ret = "";
    for (var i = 0; i < gucciUtf32.length; i++) {
      var utf32 = gucciUtf32[i];
      var val = (1 << 24) * utf32[0] +
          (1 << 16) * utf32[1] +
          (1 << 8) * utf32[2] +
          utf32[3];

      var hexVal = int.parse(val.toString()).toRadixString(16);
      while (hexVal.length < 8) {
        hexVal = "0" + hexVal;
      }
      hexVal = remove ? hexVal : "u+$hexVal";
      ret += hexVal;

      if ((i != gucciUtf32.length - 1) && remove) {
        ret += " ";
      }
    }

    /// return text
    return ret;
  } catch (_) {
    return null;
  }
}

/// code point to utf32
List codePointToUtf32(codePoint) {
  var b4 = (codePoint & 0xff000000) >> 24;
  var b3 = (codePoint & 0x00ff0000) >> 16;
  var b2 = (codePoint & 0x0000ff00) >> 8;
  var b1 = (codePoint & 0x000000ff);

  /// return list
  return [b4, b3, b2, b1];
}
