/// utf8
String utf8(String text) {
  /// if text length is 0
  if (text.length == 0) return '';

  /// check text pattern has match
  if (!RegExp(r"^(\\u|u+|)[a-z0-9 ]+").hasMatch(text)) {
    print("Hexadecimal input required");
    return "";
  }

  text = replace(text);

  /// replace text
  var input =
      text.replaceAll(RegExp(r"^\s+"), "").replaceAll(RegExp(r"\s+$"), "")
        ..replaceAll(r"\n+", " ")
        ..replaceAll(r"\t+", " ").toLowerCase();

  var ret = '';

  /// text split to list
  var gucciUtf = input.split(RegExp(r"\s+"));

  /// list for loop
  for (var i = 0; i < gucciUtf.length; i++) {
    /// get list value
    var utf16 = gucciUtf[i];

    /// if text length is 4
    if (utf16.length < 4) {
      /// while loop
      while (utf16.length < 4) {
        /// add 0 to text
        utf16 = "0" + utf16;
      }
    }

    /// convert to 16 bit
    var code = int.parse(utf16, radix: 16);

    /// add to text
    ret += String.fromCharCode(code);
  }

  /// return text
  return ret;
}

/// replace function
String replace(String text) {
  /// replace \u to space
  text = text.replaceAll(r"\u", " ");

  /// replace u+ to space
  text = text.replaceAll(r"u+", " ");

  return text;
}
